// @generated by protoc-gen-es v1.10.0 with parameter "target=ts"
// @generated from file quary/service/v1/chart_file.proto (package quary.service.v1, syntax proto3)
/* eslint-disable */
// @ts-nocheck

import type { BinaryReadOptions, FieldList, JsonReadOptions, JsonValue, PartialMessage, PlainMessage } from "@bufbuild/protobuf";
import { Message, proto3, Struct } from "@bufbuild/protobuf";

/**
 * CharFile is a representation of a chart that can be used to generate a visualization.
 *
 * @generated from message quary.service.v1.ChartFile
 */
export class ChartFile extends Message<ChartFile> {
  /**
   * description of the cart
   *
   * @generated from field: optional string description = 2;
   */
  description?: string;

  /**
   * Tags are used to group different parts of the project together. For example, you could tag all models that are
   * related to a specific department with the same tag.
   *
   * @generated from field: repeated string tags = 3;
   */
  tags: string[] = [];

  /**
   * Where the data comes from
   *
   * @generated from oneof quary.service.v1.ChartFile.source
   */
  source: {
    /**
     * raw sql that is passed to the database
     *
     * @generated from field: string raw_sql = 4;
     */
    value: string;
    case: "rawSql";
  } | {
    /**
     * sql that is passed to the database with templating through quary
     *
     * @generated from field: string pre_templated_sql = 5;
     */
    value: string;
    case: "preTemplatedSql";
  } | {
    /**
     * reference to a pre-existing asset, model, source, seed, snapshot
     *
     * @generated from field: quary.service.v1.ChartFile.AssetReference reference = 6;
     */
    value: ChartFile_AssetReference;
    case: "reference";
  } | { case: undefined; value?: undefined } = { case: undefined };

  /**
   * Configuration for the chart that is passed to perspective
   *
   * @generated from field: google.protobuf.Struct config = 7;
   */
  config?: Struct;

  constructor(data?: PartialMessage<ChartFile>) {
    super();
    proto3.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto3 = proto3;
  static readonly typeName = "quary.service.v1.ChartFile";
  static readonly fields: FieldList = proto3.util.newFieldList(() => [
    { no: 2, name: "description", kind: "scalar", T: 9 /* ScalarType.STRING */, opt: true },
    { no: 3, name: "tags", kind: "scalar", T: 9 /* ScalarType.STRING */, repeated: true },
    { no: 4, name: "raw_sql", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "source" },
    { no: 5, name: "pre_templated_sql", kind: "scalar", T: 9 /* ScalarType.STRING */, oneof: "source" },
    { no: 6, name: "reference", kind: "message", T: ChartFile_AssetReference, oneof: "source" },
    { no: 7, name: "config", kind: "message", T: Struct },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ChartFile {
    return new ChartFile().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ChartFile {
    return new ChartFile().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ChartFile {
    return new ChartFile().fromJsonString(jsonString, options);
  }

  static equals(a: ChartFile | PlainMessage<ChartFile> | undefined, b: ChartFile | PlainMessage<ChartFile> | undefined): boolean {
    return proto3.util.equals(ChartFile, a, b);
  }
}

/**
 * @generated from message quary.service.v1.ChartFile.AssetReference
 */
export class ChartFile_AssetReference extends Message<ChartFile_AssetReference> {
  /**
   * @generated from field: string name = 1;
   */
  name = "";

  constructor(data?: PartialMessage<ChartFile_AssetReference>) {
    super();
    proto3.util.initPartial(data, this);
  }

  static readonly runtime: typeof proto3 = proto3;
  static readonly typeName = "quary.service.v1.ChartFile.AssetReference";
  static readonly fields: FieldList = proto3.util.newFieldList(() => [
    { no: 1, name: "name", kind: "scalar", T: 9 /* ScalarType.STRING */ },
  ]);

  static fromBinary(bytes: Uint8Array, options?: Partial<BinaryReadOptions>): ChartFile_AssetReference {
    return new ChartFile_AssetReference().fromBinary(bytes, options);
  }

  static fromJson(jsonValue: JsonValue, options?: Partial<JsonReadOptions>): ChartFile_AssetReference {
    return new ChartFile_AssetReference().fromJson(jsonValue, options);
  }

  static fromJsonString(jsonString: string, options?: Partial<JsonReadOptions>): ChartFile_AssetReference {
    return new ChartFile_AssetReference().fromJsonString(jsonString, options);
  }

  static equals(a: ChartFile_AssetReference | PlainMessage<ChartFile_AssetReference> | undefined, b: ChartFile_AssetReference | PlainMessage<ChartFile_AssetReference> | undefined): boolean {
    return proto3.util.equals(ChartFile_AssetReference, a, b);
  }
}

