# Quary

## Introduction

Welcome to your Quary project! This README serves as a guide to help you navigate and utilize the features of your newly generated Quary project. This README template provides you with essential information on project structure, available commands, and general guidelines.

## Project Structure

Your Quary project is structured as follows:

- **`models/staging/schema.yaml`**: This is where your external sources are set up.
- **`models/`**: Contains the data models for your project.
- **`seeds/`**: (Optional) Includes seed data files for initial database setup.
- **`tests/`**: Contains custom test cases for your data models.

### Essential Commands

#### Development

- **Render Model**: `QUARY: Render Model` visualise a model.
- **Do Statement**: `QUARY: Do statement` execute arbitrary commands against your database.
- **Test**: `QUARY: Test` executes tests against all your data models.
- **Render Tables**: `QUARY: Render Tables` visualizes tables and views in the database.
- **Render Sources**: `QUARY: Render Sources` view the sources.
- **Render Full Schema**: `QUARY: Render Full Schema` view the full execution script.
- **Generate Query Helper**: `QUARY: QUARY: Generate Query Helper` AI-assisted model generation.

#### Deployment

- **Run Models**: `QUARY: Run` Deploys your data models to your database

## Command Line Interface (CLI) Tool

For users preferring a CLI tool, all the above actions can also be performed using the Quary CLI. Check the [documentation](https://www.quary.dev/docs) for detailed CLI commands.

## Documentation and Support

For more detailed information about models, seeds, sources, and advanced configurations, visit our official [documentation](https://www.quary.dev/docs).
